#Eneroth Upright Extruder

#Author:	Julia Christina Eneroth, Eneroth3, eneroth3@gmail.com

#Usage
#	Menu: Plugins
#		Upright Extrude: Extrude selected face along selected edges

#Copyright Julia Christina Eneroth (eneroh3)
#	Free to use both professional and unprofessional.
#	Free to spread as long as credit goes to me.

#Known bugs and issues
#	*	Profile's with in corners is constant but between corners the sides aren't parallel (unless the angle is 0 on both sides).
#		Scale profiles before drawing them

#Changelog
#	1.0.0 2013-05-30
#		*First release
#	1.1.0 2013-06-02
#		*Fixed small icons
#		*Extrude closed paths
#		*Fixed co-planar face bug. Use classify_point instead of comparing vectors to see if faces really really really are co-planar.
#	1.1.1 2013-06-06
#		*Called tb.show to fix hidden toolbar issue.
#		*Script cannot extrude along edges binding extrusion face. Just ignore these edges instead of raising an error and aborting.
#		*Fixed back face problem.
#		*Soften/Smooth edges extruded from curves
#	1.2.0 2013-08-06
#		*Using Sketchup::Face::PointNotOnPlane instead of 32 to classify points
#		*Cleaned up code
#		*Use point along path closest to extrusion as start point for closed path, not closest corner
#		*parallel sides of extrusion rather than fixed with in corners
#	1.2.1 2012-12-15
#		*Moved start_operation and commit_operation to userInput function to make extruder work better when called from other plugin
#   *Spelling
#   *Can now be loaded from other folder than plugin default

#Load the normal support files
require 'sketchup.rb'
require 'extensions.rb'


module Ene_uprightExtruder

PLUGIN_ROOT = File.dirname(__FILE__) unless defined?(self::PLUGIN_ROOT)

ex = SketchupExtension.new("Eneroth Upright Extruder", File.join(PLUGIN_ROOT, "/ene_uprightExtruder/main.rb"))
ex.description = "Extrudes a face along a path of edges similar to the native Follow Me but keeps the extrusion upright (or aligned to any other vector). Useful for stair railings, roads and railroads."
ex.version = "1.2.1"
ex.copyright = "Julia Christina (eneroth3) Eneroth 2013"
ex.creator = "Julia Christina (eneroth3) Eneroth"
Sketchup.register_extension ex, true

end#module